#!/usr/bin/env python
# coding: utf-8

# In[ ]:


import pandas as pd
from datetime import datetime
import time
import numpy as np
import matplotlib.pyplot as plt

# Filtering
from collections import deque
from bisect import insort, bisect_left
from itertools import islice


# Clustering
import timeit
from scipy.spatial.distance import euclidean
import scipy.spatial.distance as ssd
from dtaidistance import dtw
from joblib import Parallel, delayed
import multiprocessing
from cycler import cycler


# Internal indexes
from scipy.cluster.hierarchy import cophenet
from sklearn.metrics import silhouette_score
from scipy.spatial.distance import squareform
from scipy.cluster.hierarchy import fcluster
from scipy.cluster.hierarchy import dendrogram
import scipy.cluster.hierarchy as hac

